
/*************************************************************
  project: <type project name here>
  author: <type your name here>
  description: <type what this file does>
*************************************************************/

//#include "arduino.h"
#include "types.h"
#include "global_data.h"
#include "Menu_types.h"
#include "Interupts.h"
#include "Inputs.h"


// ==============================
// input sensing functions // the state
bool LIGHTS_IN = false;
bool UPDATE_LIGHTS_IN = false;
uint32_t Lights_In_Duration = 0;
uint32_t Lights_Button_Press = 0;

bool KILL_IN = false;
bool UPDATE_KILL_IN = false;
uint32_t Kill_In_Duration = 0;
uint32_t Kill_Button_Press = 0;

bool STARTER_IN = false;
bool UPDATE_STARTER_IN = false;
uint32_t Starter_In_Duration = 0;
uint32_t Starter_Button_Press = 0;

bool HORN_IN = false;
bool UPDATE_HORN_IN = false;
uint32_t Horn_In_Duration = 0;
uint32_t Horn_Button_Press = 0;

bool BRAKE_IN = false;
bool UPDATE_BRAKE_IN = false;
uint32_t Brake_In_Duration = 0;
uint32_t Brake_Button_Press = 0;

bool LEFT_IN = false;
bool UPDATE_LEFT_IN = false;
uint32_t Left_In_Duration = 0;
uint32_t Left_Button_Press = 0;

bool RIGHT_IN = false;
bool UPDATE_RIGHT_IN = false;
uint32_t Right_In_Duration = 0;
uint32_t Right_Button_Press = 0;

bool HIGH_IN = false;
bool UPDATE_HIGH_IN = false;
uint32_t High_In_Duration = 0;
uint32_t High_Button_Press = 0;

bool GATE_IN = false;
bool UPDATE_GATE_IN = false;
uint32_t Gate_In_Duration = 0;
uint32_t Gate_Button_Press = 0;




// persisten vals
uint16_t this_val = 0;
uint16_t last_val = 0;

// -------------------------------------------------------------------------------------------------------------
// ------------------- NORMAL --------------------------------------------------------------------------------

bool Check_Lights_In(void)
{
  if (true == LIGHTS_Event_Pending)
  {
    // process the event logic to see what needs to be done
    noInterrupts();    
    LIGHTS_Event_Pending = false;
    interrupts();
    if  (LIGHTS_Active) // set the flag to indicate and do the time processing
    {
        Lights_In_Duration = 0;
        Lights_Button_Press = millis();   // log the press time         
        LIGHTS_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("LIGHTS ON -> "));        
#endif          
    }
    else
    {
        Lights_In_Duration = millis() - Lights_Button_Press;  // work out the button time        
        LIGHTS_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("LIGHTS OFF - duration ")); 
     Serial.println(Lights_In_Duration,DEC);             
#endif       
    }   
    return (true);           
  } 
  return (false);
}

bool Check_High_In(void)
{
  if (true == HB_Event_Pending)
  {
    // process the event logic to see what needs to be done
    noInterrupts();    
    HB_Event_Pending = false;
    interrupts();
    if  (HB_Active) // set the flag to indicate and do the time processing
    {
        High_In_Duration = 0;
        High_Button_Press = millis();   // log the press time         
        HIGH_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("HIGH ON -> "));        
#endif           
    }
    else
    {
        High_In_Duration = millis() - High_Button_Press;  // work out the button time        
        HIGH_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("HIGH OFF - duration ")); 
     Serial.println(High_In_Duration,DEC);             
#endif            
    }      
    return (true);           
  } 
  return (false);
}

 
bool Check_Kill_In(void)
{
  if (true == KILL_Event_Pending)
  {
      // process the event logic to see what needs to be done
    noInterrupts();    
    KILL_Event_Pending = false;
    interrupts();
    if  (KILL_Active) // set the flag to indicate and do the time processing
    {
        Kill_In_Duration = 0;
        Kill_Button_Press = millis();   // log the press time         
        KILL_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("KILL ON -> "));        
#endif   
    }
    else
    {
        Kill_In_Duration = millis() - Kill_Button_Press;  // work out the button time        
        KILL_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("KILL OFF - duration ")); 
     Serial.println(Kill_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
}
 
bool Check_Starter_In(void)
{
  if (true == STARTER_Event_Pending)
  {
      // process the event logic to see what needs to be done
    noInterrupts();    
    STARTER_Event_Pending = false;
    interrupts();
    if  (STARTER_Active) // set the flag to indicate and do the time processing
    {
        Starter_In_Duration = 0;
        Starter_Button_Press = millis();   // log the press time         
        STARTER_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("STARTER ON -> "));        
#endif   
    }
    else
    {
        Starter_In_Duration = millis() - Starter_Button_Press;  // work out the button time        
        STARTER_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("STARTER OFF - duration ")); 
     Serial.println(Starter_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
}

 
bool Check_Horn_In(void)
{
  if (true == HORN_Event_Pending)
  {
      // process the event logic to see what needs to be done
    noInterrupts();    
    HORN_Event_Pending = false;
    interrupts();
    if  (HORN_Active) // set the flag to indicate and do the time processing
    {
        Horn_In_Duration = 0;
        Horn_Button_Press = millis();   // log the press time         
        HORN_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("HORN ON -> "));        
#endif   
    }
    else
    {
        Horn_In_Duration = millis() - Horn_Button_Press;  // work out the button time        
        HORN_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("HORN OFF - duration ")); 
     Serial.println(Horn_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
}

 
bool Check_Brake_In(void)
{
  if (true == BRAKES_Event_Pending)
  {
      // process the event logic to see what needs to be done
    noInterrupts();    
    BRAKES_Event_Pending = false;
    interrupts();
    if  (BRAKES_Active) // set the flag to indicate and do the time processing
    {
        Brake_In_Duration = 0;
        Brake_Button_Press = millis();   // log the press time         
        BRAKE_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("BRAKE ON -> "));        
#endif   
    }
    else
    {
        Brake_In_Duration = millis() - Brake_Button_Press;  // work out the button time        
        BRAKE_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("BRAKE OFF - duration ")); 
     Serial.println(Brake_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
}

  
bool Check_Left_In(void)
{
  if (true == LEFT_Event_Pending)
  {
      // process the event logic to see what needs to be done
    noInterrupts();    
    LEFT_Event_Pending = false;
    interrupts();
    if  (LEFT_Active) // set the flag to indicate and do the time processing
    {
        Left_In_Duration = 0;
        Left_Button_Press = millis();   // log the press time         
        LEFT_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("LEFT ON -> "));        
#endif   
    }
    else
    {
        Left_In_Duration = millis() - Left_Button_Press;  // work out the button time        
        LEFT_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("LEFT OFF - duration ")); 
     Serial.println(Left_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
}

  
 bool Check_Right_In(void)
{
  if (true == RIGHT_Event_Pending)
  {
      // process the event logic to see what needs to be done
    noInterrupts();    
    RIGHT_Event_Pending = false;
    interrupts();
    if  (RIGHT_Active) // set the flag to indicate and do the time processing
    {
        Right_In_Duration = 0;
        Right_Button_Press = millis();   // log the press time         
        RIGHT_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("RIGHT ON -> "));        
#endif   
    }
    else
    {
        Right_In_Duration = millis() - Right_Button_Press;  // work out the button time        
        RIGHT_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("RIGHT OFF - duration ")); 
     Serial.println(Right_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
}



// reutn if there was an event processed - ie state change occured  
 bool Check_Gate_In(void)
 {
  // GATE spin is different - polled Analog pin 
   // need to measure / get last measurment and compare - 
   // if changed - then manually do the "interupt"
   
  this_val = analogRead(INPUT_PIN_GATE_SW);// read the ADC value
  last_val = Int_GATE(this_val, last_val); // check for a changed event   
  
  if (true == GATE_Event_Pending)
  {
      // process the event logic to see what needs to be done 
    noInterrupts();         
    GATE_Event_Pending = false;
    interrupts();       
    if  (GATE_Active) // set the flag to indicate and do the time processing
    {
        Gate_In_Duration = 0;
        Gate_Button_Press = millis();   // log the press time         
        GATE_IN = true;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("GATE ON -> "));        
#endif   
    }
    else
    {
        Gate_In_Duration = millis() - Gate_Button_Press;  // work out the button time        
        GATE_IN = false;
#ifdef BUTTON_TRACE_ON
     Serial.print(F("GATE OFF - duration ")); 
     Serial.println(Gate_In_Duration,DEC);             
#endif    
    }      
    return (true);           
  } 
  return (false);
 }


// run through the inputs and check for change - update the global variables
void Do_Check_Inputs()
{
  UPDATE_LIGHTS_IN = Check_Lights_In();
  UPDATE_HIGH_IN = Check_High_In();
  UPDATE_KILL_IN = Check_Kill_In();
  UPDATE_STARTER_IN = Check_Starter_In();
  UPDATE_HORN_IN = Check_Horn_In();
  UPDATE_BRAKE_IN = Check_Brake_In();
  UPDATE_LEFT_IN = Check_Left_In();
  UPDATE_RIGHT_IN = Check_Right_In();
  UPDATE_GATE_IN = Check_Gate_In();
}

// -------------------------------------------------------------------------------------------------------------



 