
/*************************************************************
  project: <type project name here>
  author: <type your name here>
  description: <type what this file does>
*************************************************************/

//#include "arduino.h"
#include "types.h"
#include "global_data.h"
#include "Menu_types.h"

#include "Interupts.h"
#include "Inputs.h"
#include "Logic.h"
#include "Outputs.h"

#include "Menu.h"

//flow of events is 
//Interrupts go to input processing -?
// input processing takes these and creates states vairables

// ie IN - these are state and the button push duration - 0 if state driven
//  update flag if there was an interruptevent / change - needed for toggling
// LIGHTS_IN, UPDATE_LIGHTS_IN,  Lights_In_Duration;
// KILL_IN, UPDATE_LIGHTS_IN   Kill_In_Duration;
// STARTER_IN, UPDATE_STARTER_IN Starter_In_Duration;
// HORN_IN, UPDATE_HORN_IN   Horn_In_Duration;
// BRAKE_IN,UPDATE_BRAKE_IN  Brake_In_Duration;
// LEFT_IN, UPDATE_LEFT_IN  Left_In_Duration;
// RIGHT_IN,UPDATE_RIGHT_IN  Right_In_Duration;
// HIGH_IN, UPDATE_HIGH_IN  High_In_Duration;
// GATE_IN, UPDATE_GATE_IN  Gate_In_Duration;

// This logig module then uses those values to apply the rules of operation to decide what outputs to activate under what conditions for each function
// and sets the ooutput state using the variables below

// ie OUT
// HORN_OUT;
// LIGHTS_OUT;
// STARTER_OUT;
// BRAKE_OUT;
// LEFT_IND_OUT;
// RIGHT_IND_OUT;
// HIGH_BEAM_OUT;
// IGNITION_OUT;

// LOW_BEAM_OUT;     // on / off
// LOW_BEAM_PWM_ON;  // modulation flag

// SPARE_PWM_OUT_VAL;  // nummeric for pwm 
// SPARE_OUT;    // on / off



// -------------------
extern int HEAD_Num;
extern int HEAT_Num;

extern uint32_t MOD_UPDATE_INTERVAL;
extern uint8_t  HEAT_STEP_SIZE;

// Note that this module is where the evalution of any button rpess that is different versus mode would occur - eg the PWM controls are dependen on the mode of the GATE line
// and the Moulation on off - is dependant on the lenght of the high / low transition -
// we leave the auto functions like brake and indicator flashing tothe output modules so that it doesnt pollute this module



void  DumpLogicStates()
{
    // horn
    Serial.print(F("HORN In->"));
    Serial.print(HORN_IN, DEC); 
    Serial.print(F("   HORN UPDATE->"));
    Serial.print(UPDATE_HORN_IN, DEC); 
    Serial.print(F("  HORN OUT->"));
    Serial.print(HORN_OUT, DEC);
    Serial.print(F("  Dur->"));        
    Serial.println(Horn_In_Duration, DEC);  
  
   // kill  
    Serial.print(F("KILL In->"));
    Serial.print(KILL_IN, DEC); 
    Serial.print(F("   KILL UPDATE->"));
    Serial.print(UPDATE_KILL_IN, DEC); 
    Serial.print(F("  IGN OUT->"));
    Serial.print(IGNITION_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Kill_In_Duration, DEC);      
   
    // Starter
    Serial.print(F("STARTER In->"));
    Serial.print(STARTER_IN, DEC); 
    Serial.print(F("   STARTER UPDATE->"));
    Serial.print(UPDATE_STARTER_IN, DEC); 
    Serial.print(F("  STARTER OUT->"));
    Serial.print(STARTER_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Starter_In_Duration, DEC);      

    // lights
    Serial.print(F("LIGHTS In->"));
    Serial.print(LIGHTS_IN, DEC); 
    Serial.print(F("   LIGHTS UPDATE->"));
    Serial.print(UPDATE_LIGHTS_IN, DEC); 
    Serial.print(F("  LIGHTS OUT->"));
    Serial.print(LIGHTS_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Lights_In_Duration, DEC); 

    // High Beam
    Serial.print(F("HIGH In->"));
    Serial.print(HIGH_IN, DEC); 
    Serial.print(F("   HIGH UPDATE->"));
    Serial.print(UPDATE_HIGH_IN, DEC); 
    Serial.print(F("  HIGH OUT->"));
    Serial.print(HIGH_BEAM_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(High_In_Duration, DEC); 

    // Low Beam
    Serial.print(F("LIGHTS In->"));
    Serial.print(LIGHTS_IN, DEC); 
    Serial.print(F("   LIGHTS UPDATE->"));
    Serial.print(UPDATE_LIGHTS_IN, DEC); 
    Serial.print(F("  LOW OUT->"));
    Serial.print(LOW_BEAM_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Lights_In_Duration, DEC); 

    // Brake
    Serial.print(F("BRAKES In->"));
    Serial.print(BRAKE_IN, DEC); 
    Serial.print(F("   BRAKES UPDATE->"));
    Serial.print(UPDATE_BRAKE_IN, DEC); 
    Serial.print(F("  BRAKES OUT->"));
    Serial.print(BRAKE_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Brake_In_Duration, DEC);     
            
    // Left Ind
    Serial.print(F("LEFT In->"));
    Serial.print(LEFT_IN, DEC); 
    Serial.print(F("   LEFT UPDATE->"));
    Serial.print(UPDATE_LEFT_IN, DEC); 
    Serial.print(F("  LEFT OUT->"));
    Serial.print(LEFT_IND_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Left_In_Duration, DEC);  

   // Right Ind
    Serial.print(F("RIGHT In->"));
    Serial.print(RIGHT_IN, DEC); 
    Serial.print(F("   RIGHT UPDATE->"));
    Serial.print(UPDATE_RIGHT_IN, DEC); 
    Serial.print(F("  RIGHT OUT->"));
    Serial.print(LOW_BEAM_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Right_In_Duration, DEC);  
            
   // SPARE_OUT
    Serial.print(F("GATE In->"));
    Serial.print(GATE_IN, DEC); 
    Serial.print(F("  GATE UPDATE->"));
    Serial.print(UPDATE_GATE_IN, DEC); 
    Serial.print(F("  SPARE OUT->"));
    Serial.print(SPARE_OUT, DEC); 
    Serial.print(F("  Dur->"));        
    Serial.println(Gate_In_Duration, DEC);  

    Serial.print(F("GRIP OUT %->"));
    Serial.println(SPARE_PWM_OUT_VAL, DEC); 
    
    Serial.print(F("MODULATION STATE OUT->"));
    Serial.println(LOW_BEAM_MOD_ON, DEC); 


  //  Serial.print(F("EEPROM WRITTEN FLAG ->"));
  //  Serial.println(Read_Var_From_Flash(STORED_SETUP_FLAG_ADDRESS),HEX); 
   

}

// ----------------------
  
bool Are_We_Cranking(void)
{
   bool Cranking = false;  
  
   if (STARTER_IN  == true)  // so how to know if cranking - starter is on - and gate if used is active 
   {
     if ((TheConfigEpromData.Values[CONFIG_PARAM_STARTER_GATE].Bool == true) && (GATE_IN == true))                // gate and kill  used and active - the check kill 
      Cranking = (TheConfigEpromData.Values[CONFIG_PARAM_STARTER_INH_KILL].Bool == true) ? !KILL_IN : true ;

     if ((TheConfigEpromData.Values[CONFIG_PARAM_STARTER_INH_KILL].Bool == false))         // if the kill is not used / gate only
      Cranking = (TheConfigEpromData.Values[CONFIG_PARAM_STARTER_GATE].Bool == true) ? GATE_IN : true;
   } 
   return(Cranking);
}
  
 // --------------------------------------- 
  
bool PRIOR_STATE_LOW = false;
bool PRIOR_STATE_HIGH = false;
bool PRIOR_STATE_TAIL = false;

  
 bool Logic_Lights(void)
 {
   // calculate the taillight  
   // if there was an input change - 
  if (true == UPDATE_LIGHTS_IN) 
  {
    if (TheConfigEpromData.Values[CONFIG_PARAM_LIGHTS_MODE].Bool == false)  // latching mode - toggle
    {
      if (true == LIGHTS_IN)  
      {
        Serial.println(F("Toggle Lights")) ;           
        LIGHTS_OUT = (LIGHTS_OUT == true) ? false : true;                
      } 
    }  
    else // state mode
    {
      LIGHTS_OUT = LIGHTS_IN;
//      Serial.print(F("Setting LIGHTS->")) ;     
//      Serial.println(LIGHTS_OUT) ;  
    }    
  }  
  
  // OVERRIDE CONDITIONS   
  if ((TheConfigEpromData.Values[CONFIG_PARAM_LIGHT_ON_POW].Bool == true) || (LIGHTS_OUT == true))
  {
     LIGHTS_OUT = true;      
  }          
 };


 bool Logic_High_Beam(void)
 {
  bool Cranking = false;
   // calculate the high beam logic

  // calculate the High Beam
  if (true == UPDATE_HIGH_IN) 
  {  
    if (TheConfigEpromData.Values[CONFIG_PARAM_HIGH_MODE].Bool == false) // latching mode - toggle
    {
      if (true == HIGH_IN)    // toggle
      {
        Serial.println(F("Toggle HIGH")) ; 
        HIGH_BEAM_OUT = (HIGH_BEAM_OUT == true) ? false : true; 
      }         
    }  
    else // state mode
    {         
      HIGH_BEAM_OUT = HIGH_IN;   // if the input says its on - the output is on  
//      Serial.print(F("Setting HIGH->")) ;     
//      Serial.println(HIGH_BEAM_OUT) ;     
    }  
  }
  // OVERRIDE CONDITIONS 

 };
 


 
 bool Logic_Low_Beam(void)
 {
   // calculate the Low beam logic
   // overrides the  LIGHTS ON logic if needed
  if (true == UPDATE_LIGHTS_IN)
  {     
    LOW_BEAM_OUT = LIGHTS_OUT;   // uses LIGHTS OUT above normally mirros 
  }
  
  if (TheConfigEpromData.Values[CONFIG_PARAM_LOW_OUT_ACT].Bool == true)
  {  
    if (HIGH_BEAM_OUT == true)
       LOW_BEAM_OUT = true; // always on if power            
    else  
    {
        if (TheConfigEpromData.Values[CONFIG_PARAM_LIGHT_ON_POW].Bool == false)   
        {
            if (LIGHTS_OUT == false)  // taillight off 
             LOW_BEAM_OUT = false;            
        }            
    }        
  }  
  else
  { // lights and headlight not together
     if (HIGH_BEAM_OUT == true)
        LOW_BEAM_OUT = false; // always on if power 
     else
     {
        LOW_BEAM_OUT = LIGHTS_OUT; // always on if power              
     }     
  }  

  if (TheConfigEpromData.Values[CONFIG_PARAM_LIGHT_ON_POW].Bool == true)
    LOW_BEAM_OUT = true; // always on if power o     

  if ((TheConfigEpromData.Values[CONFIG_PARAM_LOW_OUT_ACT].Bool == false) && (HIGH_BEAM_OUT == true))
     LOW_BEAM_OUT = false; // always on if power 
 
  if ((TheConfigEpromData.Values[CONFIG_PARAM_LOW_OUT_ACT].Bool == false) && (HIGH_BEAM_OUT == false))
     LOW_BEAM_OUT = LIGHTS_OUT; // always on if power  
    
 };

 

 bool Logic_Ignition(void)
 {
  // calculate the Hig Beam
  if (true == UPDATE_KILL_IN)
  { 
    if (TheConfigEpromData.Values[CONFIG_PARAM_KILL_MODE].Bool == false)  // latching mode - toggle
    {
      if (true == KILL_IN)  
      {    
        Serial.println(F("Toggle KILL")) ;       
        IGNITION_OUT = (IGNITION_OUT == true) ? false : true ;   // toggle     
      }
    }  
    else // state mode
    {
      IGNITION_OUT = (KILL_IN == true) ? false : true ;   // if the input says its on - the output is on 
//      Serial.print(F("Setting IGNITION >")) ;     
//      Serial.println(IGNITION_OUT) ;     
    } 
  }   
 };
 

void Save_Light_State(void)
{
   // save the state 
  Serial.println(F("SAVE State"));    
  PRIOR_STATE_TAIL = LIGHTS_OUT;  
  PRIOR_STATE_HIGH = HIGH_BEAM_OUT;  
  PRIOR_STATE_LOW = LOW_BEAM_OUT;
  
  if (true == Are_We_Cranking())
  {
    if (TheConfigEpromData.Values[CONFIG_PARAM_LIGHTS_OFF_CRANK].Bool == true)
    {          
        LOW_BEAM_OUT = false;             
        LIGHTS_OUT = false;  
        HIGH_BEAM_OUT = false;
        STARTER_OUT = true;   // if the input says its on - the output is on  
    }  
    else
      STARTER_OUT = true;   // if the input says its on - the output is on ;
  }
}

void Restore_Light_state(void)
{
  Serial.println(F("RESTORE State"));      
  LIGHTS_OUT = PRIOR_STATE_TAIL;  
  HIGH_BEAM_OUT = PRIOR_STATE_HIGH; 
  LOW_BEAM_OUT = PRIOR_STATE_LOW;
  STARTER_OUT = false;   // if the input says its on - the output is on            
}



 bool Logic_Starter(void)
 {
  // calculate the High Beam
  if ((true == UPDATE_STARTER_IN) && (GATE_IN == true))
  {
    if (TheConfigEpromData.Values[CONFIG_PARAM_STARTER_MODE].Bool == false)  // latching mode - toggle
    {
      if (true == STARTER_IN)    // toggle 
      {
        Serial.println(F("Toggle STARTER")) ;    
        STARTER_OUT = (STARTER_OUT == true) ? false : Are_We_Cranking();  
        if (true == STARTER_OUT)  // button pressed   
          Save_Light_State();
        else 
          Restore_Light_state();    // restore state - button released
      }
    }  
    else // state mode
    {                          
      if (true == STARTER_IN)  // button pressed   
        Save_Light_State();
      else 
        Restore_Light_state();    // restore state - button released
    }             
  }

  // OVERRIDE CONDITIONS  

 };
  
 bool Logic_Horn(void)
 {
  if (true == UPDATE_HORN_IN)
  {
    if (TheConfigEpromData.Values[CONFIG_PARAM_HORN_MODE].Bool == false)  // latching mode - toggle
    {
      if (true == HORN_IN)    // toggle
      {
        Serial.println(F("Toggle HORN")) ; 
        HORN_OUT = (HORN_OUT == true) ? false : true;  
      }        
    }  
    else // state mode
    {
        HORN_OUT = HORN_IN;   // if the input says its on - the output is on  
//      Serial.print(F("Setting HORN >")) ;     
//      Serial.println(HORN_OUT);    
    }  
  }

  // OVERRIDE CONDITIONS          
 };
    
 bool Logic_Brake(void)
 {
    if (true == UPDATE_BRAKE_IN)
    {
      if (TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_MODE].Bool == false)   // latching mode - toggle
      {
        if (true == BRAKE_IN)    // toggle
        {
          Serial.println(F("Toggle BRAKE")) ; 
          BRAKE_OUT = (BRAKE_OUT == true) ? false : true;  
        }  
      }  
      else // state mode
      {
        BRAKE_OUT = BRAKE_IN;   // if the input says its on - the output is on  
//        Serial.print(F("Setting BRAKE >")) ;     
//        Serial.println(BRAKE_OUT); 
      }  
    }
    // OVERRIDE CONDITIONS
      
 };

 bool Logic_Indicators(void)
 {
    // calculate the indicator logic
    if (true == UPDATE_LEFT_IN)
    {
      if (TheConfigEpromData.Values[CONFIG_PARAM_LEFT_MODE].Bool == false)  // latching mode - toggle
      {
        if (true == LEFT_IN)    // toggle
        {          
          Serial.println(F("Toggle LEFT")) ; 
          LEFT_IND_OUT = (LEFT_IND_OUT == true) ? false : true;  
          RIGHT_IND_OUT = (LEFT_IND_OUT == true) ? false :  RIGHT_IND_OUT;  // off if left on   
         }
      }  
      else // state mode
      {  
        LEFT_IND_OUT =  LEFT_IN;
//        Serial.print(F("Setting LEFT->")) ;     
//        Serial.println(LEFT_IND_OUT); 
      }
    }
    
    if (true == UPDATE_RIGHT_IN)
    {
      if (TheConfigEpromData.Values[CONFIG_PARAM_RIGHT_MODE].Bool == false)  // latching mode - toggle
      {
        if (true == RIGHT_IN)    // toggle
        {        
          Serial.println(F("Toggle RIGHT")) ; 
          RIGHT_IND_OUT = (RIGHT_IND_OUT == true) ? false : true; 
          LEFT_IND_OUT = (RIGHT_IND_OUT == true) ? false :  LEFT_IND_OUT;  // off if left on   
        }  
      }  
      else // state mode
      {  
        RIGHT_IND_OUT =  RIGHT_IN;
//        Serial.print(F("Setting RIGHT->")) ;     
//        Serial.println(RIGHT_IND_OUT); 
      }  
    }
    // OVERRIDE CONDITIONS 
 };

 bool Logic_Modulation(void)
 {
   // calcualte the modulatation function logic ?
   // 
   //  in order to  turn the modulation on and off  the low beam needs to be on , thehigh beam should be off
  if ((true == LOW_BEAM_OUT) && (UPDATE_HIGH_IN == true))  
  { 
    if (TheConfigEpromData.Values[CONFIG_PARAM_MOD_LOW_BEAM].Bool == true)
    {
      if (HIGH_IN == false) 
      {      
        if ((High_In_Duration > MODULATION_TOGGLE_MIN_DETECT_TIME) && (High_In_Duration < MODULATION_TOGGLE_MAX_DETECT_TIME))        
          LOW_BEAM_MOD_ON = (LOW_BEAM_MOD_ON == false) ? true : false;   // toggle modulation
      }         
    }       
  }   
  return(false) ;
 };
  
 bool Logic_Grips_In(void)
 {
    // calculate the grip function logic
    // if button press was in the time range  / increment the percentage
    if ((UPDATE_STARTER_IN == true) && (GATE_IN == false))  // special combo for PWM / Control
    {             
      if ((TheConfigEpromData.Values[CONFIG_PARAM_HEATED_GRIP_ON].Bool == true) && (STARTER_IN == false))   // button released
      {
        // Serial.print("Button Press Duration:"); Serial.print(Starter_In_Duration, DEC);
        if (((Starter_In_Duration >= MIN_DUR) && (Starter_In_Duration <= MAX_SHORT)) && (true == SPARE_OUT))// short and the grips are on 
        {
          SPARE_PWM_OUT_VAL = ((SPARE_PWM_OUT_VAL >= 100) || (SPARE_PWM_OUT_VAL ==0) ) ? HEAT_STEP_SIZE : SPARE_PWM_OUT_VAL + HEAT_STEP_SIZE;
          Write_Byte_To_Flash(SPARE_PWM_OUT_VAL, STORED_HEAT_SETTING_ADDRESS);            
#ifdef BUTTON_TRACE_ON
          Serial.print(F("Changing HEAT Out -> "));
          Serial.println(SPARE_PWM_OUT_VAL);          
#endif          
        }
        else if ((Starter_In_Duration >= MIN_LONG) && (Starter_In_Duration <= MAX_LONG)) // Long
        {
          //SPARE_PWM_OUT_VAL = 0;  // reset value - 
          SPARE_OUT = (SPARE_OUT == true) ? false : true; // toggle the state
#ifdef BUTTON_TRACE_ON          
          Serial.print(F("Toggling SPARE OUT -> "));
          Serial.println(SPARE_OUT);   
#endif                   
        }
        else
          ;
      }
      else
      {
        ; // do nothing with the key combo
      }      
    }  
    return(false);
 };


 bool Logic_Fan_In(void)
 {
   // calculate the fan soft start logic 
   // uses the gate in line and hte spare / PWM out
   SPARE_OUT = GATE_IN; 
   SPARE_PWM_OUT_VAL = 100;
   return(false);
 };  


// .this one needs to usethe time funtions in order to mapp the inputs to the actual functions
void Do_Logic()
{
  bool Update_flag = false;
  
  if (true == Logic_Lights())
    Update_flag = true;

  if (true == Logic_High_Beam())
    Update_flag = true;
    
  if (true == Logic_Low_Beam())
    Update_flag = true;

  if (true == Logic_Ignition()) // igin
    Update_flag = true;
     
  if (true == Logic_Horn())
    Update_flag = true;
    
  if (true == Logic_Brake())
    Update_flag = true;

  if (true == Logic_Indicators())
    Update_flag = true;
     
  if (true == Logic_Starter())  // must be after all other light functions due to overrides
    Update_flag = true;

  // make sure that functions are after direct mappings - as then we can use the already calculated outputs to work out state
  // rather than having to evaluate the same logic twice 
  
  if (true == Logic_Modulation())  // uses LOW_BEAM_OUT
    Update_flag = true;
  
  if (true == Logic_Grips_In())   //  
    Update_flag = true;

  // if (true == Logic_Fan_In())
  //  Update_flag = true;    
}




 