//-------------------------------------------------------------------
#ifndef __Outputs_H__
#define __Outputs_H__
//-------------------------------------------------------------------
 
#include <arduino.h>

// outputs
#define OUTPUT_PIN_HIGH_BEAM     11
#define OUTPUT_PIN_LOW_BEAM       9
#define OUTPUT_PIN_LIGHT_ON      10
#define OUTPUT_PIN_STARTER        4

#define OUTPUT_PIN_LEFT_IND       8
#define OUTPUT_PIN_RIGHT_IND      6
#define OUTPUT_PIN_HORN           3

#define OUTPUT_PIN_BRAKE          7
#define OUTPUT_PIN_IGNITION       5
#define OUTPUT_PIN_SPARE          2
 



#define BASE_MOD_RATE      42 // ms
 
// output variables - incoming states
extern bool HORN_OUT;
extern bool LIGHTS_OUT;
extern bool STARTER_OUT;
extern bool BRAKE_OUT;
extern bool LEFT_IND_OUT;
extern bool RIGHT_IND_OUT;
extern bool IND_MERGE_FLAG;  // merge flag option

extern bool HIGH_BEAM_OUT;
extern bool IGNITION_OUT;

extern bool LOW_BEAM_OUT;
extern uint8_t LOW_MOD_OUT_VAL;
extern bool LOW_BEAM_MOD_ON;

extern bool SPARE_OUT;
extern uint8_t SPARE_PWM_OUT_VAL;


void Setup_Output_Pins(void);
void Process_Initial_State(void);
void Do_Outputs(void);


#endif
//-------------------------------------------------------------------
//-------------------------------------------------------------------